<template>
    <div :id="`custom-select-${table}`">
        <button @focus="showOptions" @blur="hideOptions" type="button" class="form-control"
                :id="`custom-select-${table}-button`">
            <span v-if="!selected" class="text-muted">Choose</span>
            <span v-else>{{ selected.job }}, {{ selected.title }}</span>
        </button>
        <list v-if="focus" @select:match="select" :matches="options" :table="table" :link="false"/>
        <!--<ul v-if="focus" class="list-group">
            <a v-for="(option, index) in options" :key="index" @mousedown="select(option)">
                <li class="list-group-item">
                    <h4>{{ option.name }}</h4>
                </li>
            </a>
        </ul>-->
    </div>
</template>

<script>
    import List from "@/components/List";

    export default {
        name: "custom-select",
        components: {
            List
        },
        props: {
            table: {
                type: String,
                required: true,
            },
            specification: {
                type: String,
                required: false,
            },
            selected: {
                type: Object,
                required: false,
            },
        },
        data() {
            return {
                options: [],
                focus: false,
            }
        },
        mounted() {
            this.getOptions();
        },
        methods: {
            async getOptions() {
                const response = await fetch(
                    `http://localhost:8081/api/${this.table}${this.specification ? `?${this.specification}` : ''}`
                );
                const data = await response.json();
                this.options = data;
            },
            hideOptions() {
                this.focus = false;
            },
            showOptions() {
                this.focus = true;
            },
            select(option) {
                this.$emit('select:option', option);
            },
        }
    }
</script>

<style scoped>
    button {
        text-align: left;
    }

    ul a {
        text-decoration: none;
        color: black;
    }

    ul a:hover {
        color: darkgrey;
    }

    ul a:active {
        color: dimgrey;
    }

    ul {
        position: absolute;
    }

    ul li {
        cursor: pointer;
    }
</style>